<template>
  <div class="post-container">
    Loading Status: {{ $apollo.loading }}
    <div class="row justify-content-center">
      <div class="col-3">
        <label class="form-label">Search</label>
        <input class="form-control" v-model="keyword" />
      </div>
    </div>
    <div class="mt-3">
      <button class="btn btn-primary" @click="searchKeyword">Search</button>
    </div>
    <table class="table">
      <thead>
        <tr>
          <th scope="col">#</th>
          <th scope="col">Title</th>
          <th scope="col">Body</th>
          <th scope="col">Edit Action</th>
          <th scope="col">Delete Action</th>
        </tr>
      </thead>
      <tbody>
        <tr v-for="(item, index) in dataList" :key="item.id">
          <th scope="row">{{ index + 1 }}</th>
          <td>{{ item.title }}</td>
          <td>{{ item.body }}</td>
          <td>
            <button class="btn btn-primary" @click="editPost(item)">
              Edit
            </button>
          </td>
          <td>
            <button class="btn btn-primary" @click="deletePost(item.id)">
              Delete
            </button>
          </td>
        </tr>
      </tbody>
    </table>
    <div class="row justify-content-center">
      <div class="col-3">
        <label class="form-label">Title</label>
        <input class="form-control" v-model="formData.title" />
      </div>
    </div>
    <div class="row justify-content-center">
      <div class="col-3">
        <label class="form-label">Body</label>
        <input class="form-control" v-model="formData.body" />
      </div>
    </div>
    <button class="mt-3 btn btn-primary" @click="submitAction">Submit</button>
  </div>
</template>

<script>
import {
  CREATE_POST,
  UPDATE_POST,
  DELETE_POST,
  GET_POSTS,
} from "@/graphql/post/query";

export default {
  apollo: {
    posts: {
      query: GET_POSTS,
      variables() {
        const { options } = this;
        return { options };
      },
    },
  },
  computed: {
    dataList() {
      const { posts } = this;
      return posts?.data || [];
    },
  },
  data: () => ({
    formData: {},
    options: {
      paginate: {
        page: 1,
        limit: 5,
      },
      search: {
        q: "",
      },
    },
    keyword: "",
  }),
  methods: {
    editPost(item) {
      this.formData = {
        ...item,
      };
    },
    async deletePost(id) {
      await this.$apollo.mutate({
        // Query
        mutation: DELETE_POST,
        // Parameters
        variables: {
          id,
        },
      });
    },
    async submitAction() {
      const { formData } = this;
      if (formData.id) {
        await this.$apollo.mutate({
          // Query
          mutation: UPDATE_POST,
          // Parameters
          variables: {
            id: formData.id,
            input: {
              title: formData.title,
              body: formData.body,
            },
          },
        });
      } else {
        await this.$apollo.mutate({
          // Query
          mutation: CREATE_POST,
          // Parameters
          variables: {
            input: formData,
          },
        });
      }
    },
    async searchKeyword() {
      this.options = {
        ...this.options,
        search: {
          q: this.keyword,
        },
      };
    },
  },
};
</script>
